#!/usr/bin/python
# -*- coding:utf-8 -*-

from dom import *
import scorecard
import makelogo

def newInstance():
    return NPBYahoo2005()

class NPBYahoo2005 ( scorecard.ScoreCard ):
    def __init__( self ):
        scorecard.ScoreCard.__init__( self )
        self.date = None
        self.games = []
        return
        
    def getName( self ):
        return "プロ野球 (yahoo.co.jp)"

    def getVersion( self ):
        return "2.0"

    def getSportsCategory( self ):
        return "baseball"

    def getCountry( self ):
        return "Japan"

    def getLanguage( self ):
        return "ja"
    
    def getURL( self ):
        return "http://baseball.yahoo.co.jp/npb/"
        return "http://baseball.yahoo.co.jp/npb/" #"http://www.nikkansports.com/ns/soccer/jleague/score/j1_nscore.html"

    def decode( self, contents ):
        import re
        if contents == self.getStartKeyword(): return contents
        contents = re.sub( "<option[^>]*>", "", contents )
        contents = re.sub( "<!--.{0,10}-->", "", contents )
        contents = re.sub( "alt=[^\"]([^\\\"\\s>]+)", "", contents )
        return unicode( contents, self.getEncoding() ).encode( 'utf-8' )

    def getEncoding( self ):
        return 'euc-jp'

    def getStartKeyword( self ):
        return "<!---main--->"

    def getEndKeyword( self ):
        return "<hr size=1>"

    def getIcon( self, team ):
        if team == "中日":          name = "d"
        elif team == "ヤクルト":     name = "s"
        elif team == "巨人":        name = "g"
        elif team == "阪神":        name = "t"
        elif team == "広島":        name = "c"
        elif team == "横浜":        name = "yb"
        elif team == "西武":        name = "l"
        elif team == "ソフトバンク": name = "h"
        elif team == "日本ハム":     name = "f"
        elif team == "ロッテ":      name = "m"
        elif team == "オリックス":   name = "bs"
        elif team == "楽天":        name = "e"
        try:
            uri = makelogo.getURI( 'http://www.npb.or.jp/images/npb/pet40inter_%s.gif' % name, 'npb', name, transparency=None )
            return '<img src="%s" class="logo"/>' % uri
        except Exception, e:
            return ''
        pass

    def getIgnorableTags( self ):
        return ( 'li', 'font' )
    
    def interpreteDocument( self, document ):
        self.headerclasses = ( 'teamlogo', 'team', 'score', 'team', 'teamlogo', 'place', 'status' )
        import re, sys
        self.tables = []
        table = { 'title': self.getName() + " " + self.getDate() }
        games = []
        #print document
        #sys.exit()
        elem_table = document.get_element_at_path( "/html/table/tr/td/table" )
        elem_game = None
        while elem_table != None:
            elem_game = elem_table.get_element_at_path( 'tr/td/table/tr' )
            if elem_game != None:
                break
            try:
                elem_table = elem_table.next_sibling( 'table' )
            except:
                break
            pass
        #elem_game = document.get_element_at_path( "/html/table/tr/td/table,3/tr/td/table/tr/td/table/tr" )
        if elem_game == None:
            return
        while elem_game != None:
            team1 = elem_game.get_element_at_path( 'td/table/tr/td' ).get_text()
            score = elem_game.get_element_at_path( 'td/table/tr/td,2' ).get_text()
            team2 = elem_game.get_element_at_path( 'td/table/tr/td,3' ).get_text()
            place = elem_game.get_element_at_path( 'td/table/tr,2/td' ).get_text()
            status = elem_game.get_element_at_path( 'td/table/tr,2/td,3' ).get_text()
            score = re.sub( '\\s*\-\\s*', ' - ', score )
            icon1 = self.getIcon( team1 )
            icon2 = self.getIcon( team2 )
            game = ( icon1, team1, score, team2, icon2, place, status )
            games.append( game )
            try:
                elem_game = elem_game.next_sibling( 'tr' )
            except:
                break
            pass
        table[ 'data' ] = games
        self.tables.append( table )
        return
        #print elem_game
        sys.exit()
        elem_game = document.get_element_at_path( "/html/table/tr/td/table/tr/td/table/tr" )
        while elem_game != None:
            team1 = elem_game.get_element_at_path( 'td/table/tr/td' ).get_text()
            score = elem_game.get_element_at_path( 'td/table/tr/td,2' ).get_text()
            team2 = elem_game.get_element_at_path( 'td/table/tr/td,3' ).get_text()
            place = elem_game.get_element_at_path( 'td/table/tr,2/td' ).get_text()
            status = elem_game.get_element_at_path( 'td/table/tr,2/td,3' ).get_text()
            score = re.sub( '\\s*\-\\s*', ' - ', score )
            icon1 = self.getIcon( team1 )
            icon2 = self.getIcon( team2 )
            game = ( icon1, team1, score, team2, icon2, place, status )
            games.append( game )
            try:
                elem_game = elem_game.next_sibling( 'tr' )
            except:
                break
            continue
        table[ 'data' ] = games
        self.tables.append( table )
        return

    def getDate( self ):
        if not self.date:
            return ""
        return self.date

    pass

if __name__ == "__main__":
    """unit test"""
    filename_sample = None 
    import sys
    from loader import *

    if len( sys.argv ) > 1: filename_sample = sys.argv[ 1 ]
    
    obj = newInstance()

    if obj != None and obj.isAvailable():
        url = obj.getURL()
        if filename_sample:
            data = ""
            for line in open( filename_sample ).readlines():
                data += line
                pass
            pass
        else:
            data = loadHTML( url )
            pass
        kw_start = obj.getStartKeyword()
        kw_end   = obj.getEndKeyword()
        parser = DOMConverter()
        for tag in obj.getIgnorableTags():
            parser.add_ignoring_tag( tag )
            pass
        if kw_start == None or kw_end == None:
            for line in data.split( "\n" ):
                parser.feed( obj.decode( line ) )
                pass
            pass
        else:
            flag_inside = False
            parser.feed( '<html>' )
            for line in re.split( "\n", data ):
                line = obj.decode( line.strip() )
                if flag_inside:
                    if line.count( kw_end ): flag_inside = False
                    else: parser.feed( line )
                elif line.count( kw_start ):
                    flag_inside = True
                    pass
                pass
            parser.feed( '</html>' )
            pass
        document = parser.get_document()
        obj.interpreteDocument( document )
        print obj.toHTML()
        pass
    pass
